MultiOverlayV3 = {};
MultiOverlayV3.modDir = g_currentModDirectory;
MultiOverlayV3.settingsDir = getUserProfileAppPath().. "modsSettings/MultiOverlayV3/";
MultiOverlayV3.detiServerDir = getUserProfileAppPath();
MultiOverlayV3.artDesignDir = MultiOverlayV3.settingsDir.. "artDesign/";
MultiOverlayV3.appDir = MultiOverlayV3.settingsDir.. "app/";
MultiOverlayV3.saveGameDir = "";
MultiOverlayV3.pathSavegame = "";
MultiOverlayV3.pathMap = "";

MultiOverlayV3.metadata = {
	interface = " FS19 1.x",
	title = "MultiOverlayV3 Hud",
	notes = " Zeigt Aktuelle Preise/Bestände und vieles mehr in einem Tablet/PDA/Slot Hud an",
	author = " (by HappyLooser)",
	version = " v3.22 Alpha",
	xmlVersion = 0.1,
	artDesignVersion = 0.1,
	clientModuleVersion = 0.1;
	serverModuleVersion = 0.1;
	clientAppVersion = 0.1;
	serverAppVersion = 0.1;
	datum = " 20.03.2018",
	update = " 17.01.2021",
	web = " http://www.minetropolis.de/",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

function MultiOverlayV3:loadMap(mapName)		
	print("---loading ".. tostring(MultiOverlayV3.metadata.title).. tostring(MultiOverlayV3.metadata.version).. tostring(MultiOverlayV3.metadata.author).. "---")	
	MultiOverlayV3.appCmd = {};
	MultiOverlayV3.loadError = false;
	MultiOverlayV3.loadHostServer = false;
	MultiOverlayV3.loadDetiServer = false;
	MultiOverlayV3.isMp = g_currentMission.missionDynamicInfo.isMultiplayer;
	MultiOverlayV3.pathMap = tostring(mapName);
	MultiOverlayV3.saveGameDir = MultiOverlayV3.settingsDir.. "savegame".. g_currentMission.missionInfo.savegameIndex.. "/";
	MultiOverlayV3.pathSavegame = g_currentMission.missionInfo:getSavegameDirectory(g_currentMission.missionInfo.savegameIndex);
	MultiOverlayV3.isServer = false;
	MultiOverlayV3.hlDebugMode = false;
	MultiOverlayV3.mapIsLoad = false;
	if g_server ~= nil then MultiOverlayV3.isServer = true;end;
	MultiOverlayV3.isClient = false;
	if g_client ~= nil then MultiOverlayV3.isClient = true;end;
	if MultiOverlayV3.isMp and MultiOverlayV3.isServer and MultiOverlayV3.isClient and g_dedicatedServerInfo == nil then MultiOverlayV3.loadHostServer = true;end;
	if MultiOverlayV3.isMp and MultiOverlayV3.isServer and MultiOverlayV3.isClient and g_dedicatedServerInfo ~= nil then MultiOverlayV3.loadDetiServer = true;MultiOverlayV3.appDir = MultiOverlayV3.detiServerDir.. "app/";end;
	generateFolders();
	loadScripts(1);	
	if not MultiOverlayV3.loadDetiServer or MultiOverlayV3.loadHostServer then		
		loadScripts(2);
		moColors:loadColorXml();
		moLanguageXml:loadTable(self);		
	
		moSetGetExtras:createTimers(self); --old LS 17
		moSetGetExtras:addTimer({true}); --new LS 19
		moXmlSettings:load(self, false, true, false, false, false);	
		MultiOverlayV3.appsFound = {};	
		MultiOverlayV3.app = {};
		MultiOverlayV3.otherMods = {};
		MultiOverlayV3.dragDropPos = {on=false, whatDragDrop="", whereDragDrop="", warning=""};
		--source(MultiOverlayV3.appDir.."testScript.lua");
		--testScript:loadTest()
		moSetGetOverlays:loadTables(self);
		moGeneralSettings.clickAreas.pda = {};
		moGeneralSettings.clickAreas.slot = {};
		moGeneralSettings.clickAreas.simpleAppPDA = {};
		moGeneralSettings.clickAreas.previewIcons = {};		
		--moXmlSettings:load(self, serverXml, languageXml, objectXml, clientXml, appXml)	
		MultiOverlayV3.ownCmdTable = 0;
		MultiOverlayV3.moduleCmdTable = 0;		
		moSetGetCmd:generateOwnCmd();
		loadScripts(4);
		moXmlSettings:load(self, false, false, false, false, true); --set backupXML over clientSettings, clientSettings needs app icons
		if moDraw == nil then
			moDraw = {};
		end;	
		moSetGetOverlays:loadExtraPreviewIcons();
		moXmlSettings:load(self, false, false, false, true, false);
		moSetGetOverlays:loadAllOverlays(self);	
		loadScripts(3);
		guiMenueGenerate:addGuiMenue(self);	
	end;
	MultiOverlayV3:setAppValues(nil, false, nil, false, false, true, false, MultiOverlayV3:getServer());
	
	--input register
	if not MultiOverlayV3.loadDetiServer or MultiOverlayV3.loadHostServer then
		--Player.registerActionEvents = Utils.appendedFunction(Player.registerActionEvents, MultiOverlayV3.registerActionEventsPlayer);
		FSBaseMission.registerActionEvents = Utils.appendedFunction(FSBaseMission.registerActionEvents, MultiOverlayV3.registerActionEventsPlayer);
		--input register
		MultiOverlayV3.allowedCharacters = moSetGetExtras:getAllowedCharacters();
		MultiOverlayV3.utf8normalization = moSetGetExtras:getUtf8normalization();
	end;
	--if g_guiMenueInOutPutTextDialog ~= nil then
	--	print("________setze TextInputDialog New")
		--g_guiMenueInOutPutTextDialog = MultiOverlayV3:getTableCopy(TextInputDialog);
		--g_gui.nameScreenTypes["guiMenueInOutPutTextDialog"] = MultiOverlayV3:getTableCopy(g_gui.nameScreenTypes["TextInputDialog"]);
		--g_gui.guis["guiMenueInOutPutTextDialog"] = MultiOverlayV3:getTableCopy(g_gui.guis["TextInputDialog"]);
	--end;	
	--local isAddTimer, errorTxt = moSetGetExtras:addTimer({name="TestTimer", delay=10, repeatable=5})
	Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, MultiOverlayV3.onStartMission);	
end;

function MultiOverlayV3:onStartMission()
	if moGeneralSettings.modOn then MultiOverlayV3:setAppValues(nil, false, nil, false, false, false, true, MultiOverlayV3:getServer());end;
	if not MultiOverlayV3:getServer() then moModule:onStartMission();MultiOverlayV3:searchOtherMods();end;	
	--moSetGetCmd:generateSlotOpenCloseCmd();
	--moSetGetOverlays.slot["masterSLOT_"].cmd[1] = {name="moFillTypesActivated", from="multioverlayV3Hud", fromRealName="MultiOverlayV3 Hud"};
	--moSetGetOverlays.slot["masterSLOT_"].cmd[2] = {name="moFillTypesDeactivated", from="multioverlayV3Hud", fromRealName="MultiOverlayV3 Hud"};
	--moSetGetMohSLOT:resetRenderViewLines("masterSLOT_");
	
	--moSetGetOverlays.slot["slave1SLOT_"] = MultiOverlayV3:getTableCopy(moSetGetOverlays.slotDefault);
	--moSetGetOverlays:loadSlotOverlays(self, nil, "slave1SLOT_");
	--moSetGetCmd:generateSlotOpenCloseCmd("slave1SLOT_");		
	--moSetGetOverlays.slot["slave1SLOT_"].cmd[1] = {name="moFillTypesAndAmount", from="multioverlayV3Hud", fromRealName="MultiOverlayV3 Hud"};
	--moSetGetOverlays.slot["slave1SLOT_"].cmd[2] = {name="moSellingStationsTotal", from="multioverlayV3Hud", fromRealName="MultiOverlayV3 Hud"};		
	--moSetGetMohSLOT:resetRenderViewLines("slave1SLOT_");
	
	--moSetGetOverlays.slot["slave2SLOT_"] = MultiOverlayV3:getTableCopy(moSetGetOverlays.slotDefault);
	--moSetGetOverlays:loadSlotOverlays(self, nil, "slave2SLOT_");
	--moSetGetCmd:generateSlotOpenCloseCmd("slave2SLOT_");	
	--moSetGetOverlays.slot["slave2SLOT_"].cmd[1] = {name="moFillTypesAmountPrice", from="multioverlayV3Hud", fromRealName="MultiOverlayV3 Hud"};
end;

function MultiOverlayV3:registerActionEventsPlayer()    
    -- InputBinding.registerActionEvent(g_inputBinding, actionName, object, functionForTriggerEvent, triggerKeyUp, triggerKeyDown, triggerAlways, isActive)
	local __, eventName = InputBinding.registerActionEvent(g_inputBinding, 'MoV3OnOffMouseCursor', self, MultiOverlayV3.actionKeyMouse ,false ,true ,false ,true)
    g_inputBinding.events[eventName].displayIsVisible = false;
	--DebugUtil.printTableRecursively(g_inputBinding,"-",0,2)
end;

function MultiOverlayV3:actionKeyMouse(actionName, keyStatus, arg4, arg5, arg6)	
	if not MultiOverlayV3.dragDropPos.on and not g_currentMission.guiMenue.master.isDragDrop() then
		if not moGeneralSettings.modOn and actionName == "MoV3OnOffMouseCursor" then 
			moMouseKeyEvents:setKey(self, unicode, sym, modifier, isDownKey, true, true); 
		elseif actionName == "MoV3OnOffMouseCursor" then
			moMouseKeyEvents:setKey(self, unicode, sym, modifier, isDownKey, false, true);	
		end;
	end;
end;

function MultiOverlayV3:deleteMap()
	if moGeneralSettings.modOn then MultiOverlayV3:setAppValues(nil, false, nil, false, true, false, false, MultiOverlayV3:getServer());end;
	if MultiOverlayV3:getServer() then return;end;
	MultiOverlayV3:saveSettings(self, "clientSettings");
	moSetGetOverlays:deleteAllOverlays(self);
end;

function MultiOverlayV3:mouseEvent(posX, posY, isDown, isUp, button)
	if moGeneralSettings.modOn then MultiOverlayV3:setAppValues(nil, false, {nil, nil, nil, nil, posX, posY, isDown, isUp, button}, false, false, false, false, MultiOverlayV3:getServer());end;
	if MultiOverlayV3:getServer() or MultiOverlayV3:get_hl("getIngameMap", {}, "getIngameMap") or MultiOverlayV3:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	MultiOverlayV3.mouseCursor = {posX=posX, posY=posY, isDwon=isDown, isUp=isUp, button=button};
	moMouseKeyEvents:setKeyMouse(self, nil, nil, nil, nil, posX, posY, isDown, isUp, button);
end;

local testKey = false;
function MultiOverlayV3:keyEvent(unicode, sym, modifier, isDown)
	if testKey and not MultiOverlayV3:getServer() then moMouseKeyEvents:setKeyMouseTest(self, unicode, sym, modifier, isDown, nil, nil, nil, nil, nil);end;
	if moGeneralSettings.modOn then MultiOverlayV3:setAppValues(nil, false, {unicode, sym, modifier, isDown, nil, nil, nil, nil, nil}, false, false, false, false, MultiOverlayV3:getServer());end;
	if MultiOverlayV3:getServer() or MultiOverlayV3:get_hl("getIngameMap", {}, "getIngameMap") or MultiOverlayV3:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	moMouseKeyEvents:setKeyMouse(self, unicode, sym, modifier, isDown, nil, nil, nil, nil, nil);
end;

function MultiOverlayV3:update(dt)	
	if moGeneralSettings.modOn then MultiOverlayV3:setAppValues(dt, false, nil, true, false, false, false, MultiOverlayV3:getServer());end;
	if MultiOverlayV3:getServer() or MultiOverlayV3:get_hl("getIngameMap", {}, "getIngameMap") or MultiOverlayV3:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	moModule:update(dt);
	if g_currentMission.guiMenue.mapIsLoad and not MultiOverlayV3.mapIsLoad then MultiOverlayV3.mapIsLoad = true;
		if g_currentMission.guiMenue ~= nil and g_currentMission.guiMenue.master ~= nil then
			local isNumber = g_currentMission.guiMenue.master.getYourMenue(tostring(MultiOverlayV3.metadata.title));			
			if isNumber == nil or isNumber == 0 then MultiOverlayV3.guiMenue.on = nil;isNumber=0;end;
			MultiOverlayV3.guiMenue.modTable = isNumber;
			moSetGetGuiMenue:refreshAllSideCmdPullDownLine();
		end;
	end;
	moSetGetExtras:setTimers(self); --old LS 17
	moSetGetExtras:update_timers(dt); --new	LS 19	
	moMouseKeyEvents:coursorAutoOffTimer();
	if moGeneralSettings.setMouseCursor then g_inputBinding:setShowMouseCursor(true);end; 
	if moGeneralSettings.setFrozen then g_currentMission.isPlayerFrozen = true;end;		
	if g_currentMission.guiMenue.master.isReturnClick(MultiOverlayV3.guiMenue.modTable, true) then moGuiMenueClick:setReturnClick(self);g_currentMission.guiMenue.master.resetReturnClick(MultiOverlayV3.guiMenue.modTable);end; 	
	--if guiMenueSettings:getSave(self) then guiMenueSettings:setSave(self);end; --over onSaveCallback Gui Menue ...generateModMenue...
end;

function MultiOverlayV3:draw()
	if moGeneralSettings.modOn then MultiOverlayV3:setAppValues(nil, true, nil, false, false, false, false, MultiOverlayV3:getServer());end;	
	if MultiOverlayV3:getServer() or MultiOverlayV3:get_hl("getIngameMap", {}, "getIngameMap") or MultiOverlayV3:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;	
	--if moGeneralSettings.testDraw then moSetGetOverlays.previewAppIcons[1]:render();end;	
	--respect settings for other mods (not every mod) that's why
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
	
	if moGeneralSettings.modOn then
		local openMohPDAs = moSetGetMohPDA:getOpenPDAs();
		if #openMohPDAs > 0 then
			for pda=1, #openMohPDAs do				
				moDraw.mohPDA:setOpenDraw(self, openMohPDAs[pda]);
			end;
		end;
		local openMohSLOTs = moSetGetMohSLOT:getOpenSLOTs();
		if #openMohSLOTs > 0 then	
			for slot=1, #openMohSLOTs do
				moDraw.mohSLOT:setOpenDraw(self, openMohSLOTs[slot]);
			end;
		end;
		if moSetGetOverlays.iconPreviewPDA.isOpen then
			moDraw.iconPreviewPDA:setOpen(self);
		end;
	end;
	moDraw.infoHelpBox:setOpenDraw();	
	if moGeneralSettings.other.miniMapAutoState0 then				
		if g_gameSettings:getValue("ingameMapState") == 2 then g_currentMission.hud.ingameMap.state = 0;g_gameSettings:setValue("ingameMapState", 0);g_inputBinding:setActionEventTextVisibility(g_currentMission.hud.ingameMap.toggleMapSizeEventId, g_currentMission.hud.ingameMap.state == IngameMap.STATE_OFF);end;
	end;
	if moGeneralSettings.testNumber ~= nil then		 
		setTextBold(true);
		renderText(0.1, 0.16, 0.010, tostring(moGeneralSettings.testNumber));		
	end;	
	if string.len(moGeneralSettings.testString) > 0 then
		setTextBold(true);
		renderText(0.1, 0.20, 0.010, "-Moh- ".. tostring(moGeneralSettings.testString));
	end;
	if string.len(moGeneralSettings.testString1) > 0 then
		setTextBold(true);
		renderText(0.1, 0.18, 0.010, "-Moh- ".. tostring(moGeneralSettings.testString1));
	end;	
	--respect settings for other mods
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;
addModEventListener(MultiOverlayV3);

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function MultiOverlayV3:searchOtherMods()
	local env = getfenv(0);		
	if env["FS19_AutoDrive"] ~= nil and env["FS19_AutoDrive"]["AutoDrive"] ~= nil then
		MultiOverlayV3.otherMods.autoDrive = env["FS19_AutoDrive"];		
	end;
	if env["FS19_Courseplay"] ~= nil and env["FS19_Courseplay"]["courseplay"] ~= nil then
		MultiOverlayV3.otherMods.courseplay = env["FS19_Courseplay"];		
	end;
	if env["FS19_GlobalCompany"] ~= nil and env["FS19_GlobalCompany"]["GlobalCompany"] ~= nil then
		MultiOverlayV3.otherMods.gc = env["FS19_GlobalCompany"];		
	end;
end;

function MultiOverlayV3:saveSettings(self, settingsFile)
	if settingsFile == "clientSettings" then moSetGetClientSettings:saveConfig(self);end;	
end;

function getInputEvent(self)
	if InputBinding.hasEvent(InputBinding.MoV3OnOff) then		
		return true;
	elseif InputBinding.hasEvent(InputBinding.MoV3OnOffMouseCursor) then
		return true;
	end;
	return false;
end;

function loadScripts(int)
	if int == 1 then
		source(MultiOverlayV3.modDir.."defaultSettings/moLoadTables.lua");
	end;
	if int == 2 then
		source(MultiOverlayV3.modDir.."defaultSettings/moLoadTables.lua");
		source(MultiOverlayV3.modDir.."defaultSettings/moLanguageXml.lua");
		source(MultiOverlayV3.modDir.."defaultSettings/moXmlSettings.lua");
		source(MultiOverlayV3.modDir.."defaultSettings/moColors.lua");
		source(MultiOverlayV3.modDir.."mouseKeyEvents/moMouseKeyEvents.lua");		
		source(MultiOverlayV3.modDir.."scripte/moSetGetExtras.lua");
		source(MultiOverlayV3.modDir.."scripte/moCmd.lua");
		source(MultiOverlayV3.modDir.."scripte/moSetGetCmd.lua");		
		source(MultiOverlayV3.modDir.."scripte/moSetGetOverlays.lua");
		source(MultiOverlayV3.modDir.."scripte/moSetGetMohPDA.lua");
		source(MultiOverlayV3.modDir.."scripte/moSetGetMohSLOT.lua");
		source(MultiOverlayV3.modDir.."_hl.lua");		
	end;
	if int == 3 then		
		source(MultiOverlayV3.modDir.."scripte/draw/moDrawMohPDA.lua");
		source(MultiOverlayV3.modDir.."scripte/draw/moDrawSimpleAppPDA.lua");
		source(MultiOverlayV3.modDir.."scripte/draw/moDrawMohSLOT.lua");
		source(MultiOverlayV3.modDir.."scripte/draw/moDrawMohSLOT_Type.lua");
		source(MultiOverlayV3.modDir.."scripte/draw/moDrawInfoHelpBox.lua");
		source(MultiOverlayV3.modDir.."scripte/draw/moDrawIconPreviewPDA.lua");
		source(MultiOverlayV3.modDir.."scripte/moGuiMenue/guiMenueGenerate.lua");
		source(MultiOverlayV3.modDir.."scripte/moGuiMenue/moSetGetGuiMenue.lua");
		source(MultiOverlayV3.modDir.."scripte/moConfirm.lua");		
	end;
	if int == 4 then
		source(MultiOverlayV3.modDir.."scripte/module/moModule.lua");
		source(MultiOverlayV3.modDir.."slotsOutputTables/slotOutputTables.lua");
	end;
	--source(MultiOverlayV3.modDir.."scripte/moSetGetImages.lua");
	--source(MultiOverlayV3.modDir.."slotsMode/loadSlotsSettings.lua");
	--source(MultiOverlayV3.modDir.."slotsMode/slotsSetGetXml.lua");
	--source(MultiOverlayV3.modDir.."tabletMode/loadTabletSettings.lua");
	--source(MultiOverlayV3.modDir.."tabletMode/tabletSetGetXml.lua");
end;

function MultiOverlayV3:getServer()	
	return MultiOverlayV3.loadDetiServer;
end;

function MultiOverlayV3:getHostServer()	
	return MultiOverlayV3.loadHostServer;
end;

function MultiOverlayV3:mouseIsInArea(mouseX, mouseY, areaX1, areaX2, areaY1, areaY2)
	return mouseX >= areaX1 and mouseX <= areaX2 and mouseY >= areaY1 and mouseY <= areaY2;
end;

function generateFolders()
	createFolder(getUserProfileAppPath().. "modsSettings/");
	createFolder(MultiOverlayV3.settingsDir);
	createFolder(MultiOverlayV3.appDir);		
	if not MultiOverlayV3:getServer() then
		createFolder(MultiOverlayV3.artDesignDir);		
	end;
end;

--getfenv()[modifySetGetGui.showGui.clickAreas[a].getIconFunction](self)
function MultiOverlayV3:setAppValues(dt, draw, keyMouse, update, deleteMap, loadMap, onStartMission, isServer)	
	if isServer then return;end; --server apps not active
	if #MultiOverlayV3.appsFound > 0 then
		for a=1, #MultiOverlayV3.appsFound do
			if MultiOverlayV3.appsFound[a] ~= nil and MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString] ~= nil then
				if loadMap and MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString].loadMap ~= nil then MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString]:loadMap(self);end;
				if draw and MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString].draw ~= nil then MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString]:draw(self);end;
				if update and MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString].update ~= nil then MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString]:update(self, dt);end;
				if deleteMap and MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString].deleteMap ~= nil then MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString]:deleteMap(self);end;
				if keyMouse ~= nil and MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString].keyMouseEvent ~= nil then MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString]:keyMouseEvent(self, unpack(keyMouse));end;
				if onStartMission and MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString].onStartMission ~= nil then MultiOverlayV3[MultiOverlayV3.appsFound[a].sourceString]:onStartMission(self);end;
			end;
		end;
	end;	
end;

function MultiOverlayV3:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if MultiOverlayV3.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" and g_currentMission.hl[args] ~= nil then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if MultiOverlayV3.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if MultiOverlayV3.hlDebugMode and (not isOkay or foundArgsError) then MultiOverlayV3:setDebug("MultiOverlayV3Mod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;

function MultiOverlayV3:setDebug(argsMod, args1, errorTxt, args2, args3)	
	if g_currentMission.hl.debug == nil then g_currentMission.hl.debug = {};end;
	if g_currentMission.hl.debug[argsMod] == nil then g_currentMission.hl.debug[argsMod] = {};end;
	local errorString = "Trigger: ".. tostring(args1).. " -errorTxtCall: ".. tostring(errorTxt).. " -argsError: ".. tostring(args2).. " -resultError: ".. tostring(args3);
	local alreadyExists = false;
	if #g_currentMission.hl.debug[argsMod] == 0 then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));else
		for key,value in pairs(g_currentMission.hl.debug[argsMod]) do			
			if tostring(value) == errorString and string.len(value) == string.len(errorString) then alreadyExists=true;break;end;			
		end;		
		if not alreadyExists then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));end;
	end;	
end;

function MultiOverlayV3:stopDragDrop(self)	
	MultiOverlayV3.dragDropPos.on = false;	
	MultiOverlayV3.dragDropPos.whatDragDrop = "";	
	MultiOverlayV3.dragDropPos.whereDragDrop="";
	MultiOverlayV3.dragDropPos.warning = "";
end;

function MultiOverlayV3:getTableCopy(oldTable)
	function table.copy(oldTable)
		local newTable = {};
		for k,v in pairs(oldTable) do
			if type(v) == "table" then
				newTable[k] = table.copy(v);
			else
				newTable[k] = v;
			end;
		end;
		return newTable;
	end;
	return table.copy(oldTable);
end;

function MultiOverlayV3:sortTable(sortTable)
	function comp(w1,w2)			
		if w1 > w2 then
			return true;
		end;			
	end;	
	table.sort(sortTable, comp);	
end;

function MultiOverlayV3:tableToString(tt, indent, done)
	--print(DebugUtil.printTableRecursively(lineTable, "fillTypes ", 0, 5))	
	--print(tostring(MultiOverlayV3:tableToString(...)));
	--for key, value in pairs(.....) do
	--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
	--end;	
	done = done or {}
	indent = indent or 0
	if type(tt) == "table" then
		local sb = {}
		for key, value in pairs (tt) do
			table.insert(sb, string.rep (" ", indent))
			if type (value) == "table" and not done [value] then
				done [value] = true
				table.insert(sb, "{\n");
				table.insert(sb, MultiOverlayV3:tableToString (value, indent + 2, done))
				table.insert(sb, string.rep (" ", indent))
				table.insert(sb, "}\n");
			elseif "number" == type(key) then
				table.insert(sb, string.format("\"%s\"\n", tostring(value)))
			else
				table.insert(sb, string.format("%s = \"%s\"\n", tostring(key), tostring(value)))
			end
		end
		return table.concat(sb)
	else
		if tt == nil then return "table error.........";end;
		return tt .. "\n"
	end
end
-------------------------
function MultiOverlayV3.prerequisitesPresent(specializations)
	return true;
end

function MultiOverlayV3.registerEventListeners(vehicleType)	
	local functionNames = {	"onLoad", "onPostLoad", "saveToXMLFile" };	
	for _, functionName in ipairs(functionNames) do
		SpecializationUtil.registerEventListener(vehicleType, functionName, MultiOverlayV3);
	end
end

function MultiOverlayV3:onLoad(savegame)
	self.spec_vehicleSmallApp = {saveTab=false};	
	if savegame ~= nil then		
		local saveTab = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key .. ".vehicleSmallApp#saveTab"), false);
		self.spec_vehicleSmallApp.saveTab = saveTab;				
	end;
end;

function MultiOverlayV3:onPostLoad(savegame)
	self.spec_vehicleSmallApp = {saveTab=false};	
	if savegame ~= nil then		
		local saveTab = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key .. ".vehicleSmallApp#saveTab"), false);
		self.spec_vehicleSmallApp.saveTab = saveTab;		
	end;
end;

function MultiOverlayV3:saveToXMLFile(xmlFile, key)	
	if self.spec_vehicleSmallApp ~= nil then	
		setXMLBool(xmlFile, key.. '#saveTab', self.spec_vehicleSmallApp.saveTab);	
	end;
end;